<?php

declare(strict_types=1);

namespace App\Policies;

use App\Models\Journalist;
use Illuminate\Auth\Access\HandlesAuthorization;
use Illuminate\Foundation\Auth\User as AuthUser;

class JournalistPolicy
{
    use HandlesAuthorization;

    public function viewAny(AuthUser $authUser): bool
    {
        return $authUser->can('ViewAny:Journalist');
    }

    public function view(AuthUser $authUser, Journalist $journalist): bool
    {
        return $authUser->can('View:Journalist');
    }

    public function create(AuthUser $authUser): bool
    {
        return $authUser->can('Create:Journalist');
    }

    public function update(AuthUser $authUser, Journalist $journalist): bool
    {
        return $authUser->can('Update:Journalist');
    }

    public function delete(AuthUser $authUser, Journalist $journalist): bool
    {
        return $authUser->can('Delete:Journalist');
    }

    public function restore(AuthUser $authUser, Journalist $journalist): bool
    {
        return $authUser->can('Restore:Journalist');
    }

    public function forceDelete(AuthUser $authUser, Journalist $journalist): bool
    {
        return $authUser->can('ForceDelete:Journalist');
    }

    public function forceDeleteAny(AuthUser $authUser): bool
    {
        return $authUser->can('ForceDeleteAny:Journalist');
    }

    public function restoreAny(AuthUser $authUser): bool
    {
        return $authUser->can('RestoreAny:Journalist');
    }

    public function replicate(AuthUser $authUser, Journalist $journalist): bool
    {
        return $authUser->can('Replicate:Journalist');
    }

    public function reorder(AuthUser $authUser): bool
    {
        return $authUser->can('Reorder:Journalist');
    }
}
